/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.shop.utils.TimingQueue
 *  mkdb.ThreadHelper
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 */
package fire.pb.shop.srv.market;

import fire.pb.shop.utils.TimingQueue;
import java.util.concurrent.TimeUnit;
import mkdb.ThreadHelper;
import mkio.Protocol;
import org.apache.log4j.Logger;

public class MarketThread
extends ThreadHelper {
    private static final Logger LOG = Logger.getLogger((String)"MARKET");
    private static final String THREAD_NAME = "MarketThread";
    private static final int MAX_QUEUE_SIZE = 100;
    private final TimingQueue<Protocol> fastProtocols = new TimingQueue(100);
    private final TimingQueue<Protocol> slowProtcols = new TimingQueue(25);

    private MarketThread(String name) {
        super(name);
    }

    public static MarketThread getInstance() {
        return MarketThreadHolder.instance;
    }

    public void run() {
        while (this.isRunning() || !this.fastProtocols.isEmpty()) {
            try {
                Protocol fastP = (Protocol)this.fastProtocols.poll(20L, 5L, TimeUnit.SECONDS);
                if (null == fastP) continue;
                fastP.run();
            }
            catch (Exception e) {
                LOG.error((Object)"err", (Throwable)e);
            }
        }
    }

    public boolean tryAdd(Protocol p) {
        if (p.getType() >= 810639 && p.getType() <= 810664) {
            try {
                if (this.fastProtocols.size() < 100) {
                    return this.fastAdd(p);
                }
                if (LOG.isInfoEnabled()) {
                    LOG.info((Object)"拍卖快查询队列已满, 拒绝新的请求服务!");
                }
                return true;
            }
            catch (Exception e) {
                LOG.error((Object)"拍卖主线程：", (Throwable)e);
                return true;
            }
        }
        return false;
    }

    public boolean fastAdd(Protocol p) {
        return this.fastProtocols.add((Object)p);
    }

    public boolean slowAdd(Protocol p) {
        return this.slowProtcols.add((Object)p);
    }

    public void clear() {
        this.fastProtocols.clear();
    }

    static class MarketThreadHolder {
        static MarketThread instance = new MarketThread("MarketThread");

        MarketThreadHolder() {
        }
    }
}

